var synapseCustomDesignCfParent = AJS.$('#synapseCustomDesignCfParent').val();

var issueItemSummaryContainerClassCfParent = "synapse-parents-widget-info";
var issueItemWrapperClassCfParent = "synapse-parents-wrapper-table";
var issueItemRightIconClassCfParent = "synapse-parents-right-text-icon";
if(synapseCustomDesignCfParent == "true"){
	issueItemSummaryContainerClassCfParent = "synapse-cf-issue-item-summary";
	issueItemWrapperClassCfParent = "synapse-custom-cf-issue-item-wrapper";
	issueItemRightIconClassCfParent = "synapse-custom-cf-issue-item-right-icon";
}

function selectedCfParent(obj) {
    AJS.$('#CfParent').val(AJS.$(obj).parents('div.' + issueItemWrapperClassCfParent).attr('key'));

    var tdData = AJS.$('#selected-CfParent');
    tdData.empty();
    AJS.$(obj).parents('div.' + issueItemWrapperClassCfParent).clone().appendTo(tdData);

    var selectedWidget = tdData.children('div.' + issueItemWrapperClassCfParent);
    selectedWidget.find('.synapse-parents-left-icon').remove();
    selectedWidget.find('.synapse-custom-cf-issue-item-left-icon').remove();
    selectedWidget.find('.' + issueItemRightIconClassCfParent).remove();

    truncateText(selectedWidget.find('.' + issueItemSummaryContainerClassCfParent));

    AJS.$(obj).attr('checked', 'checked');
}

function getContentForIssueCfParent(issue, parent) {
    var content = AJS.$('<div/>', {
        key: issue.key,
        parent: parent
    });
	
	content.addClass(issueItemWrapperClassCfParent);

    var n = parseInt(issue.level, 10);
    var spacer;
    for(var i = 0; i < n; i++) {
        spacer = AJS.$('<div/>')
				.addClass('synapse-parents-tree-spacer synapse-parents-table-cell')
				.append('&nbsp;');

        if(i == n - 1) {
            spacer.append(AJS.$('<img/>', {
                src: AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/up_to_right_arrow.png'
            }).addClass('synapse-parents-img-tag'));
        }

        content.append(spacer);
    }
	if(synapseCustomDesignCfParent == "true"){
		var widget = AJS.$('<div/>').addClass('synapse-custom-cf-issue-item-widget');

		var widgetNavigation = AJS.$('<div/>').addClass('synapse-parents-widget-navigation').css('background-color', issue.issuetypecolor);

		if(issue.isExistsChilds) {
			var plusContainer = AJS.$('<div/>');
			widget.append(
				plusContainer.append(				
					AJS.$('<img/>', {
						src: AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/plus.png',
						click: function() {
							var imgUrl = AJS.$(this).attr('src');
							if(imgUrl.endsWith('/plus.png')) {
								AJS.$(this).attr('src', AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/minus.png')
								loadParentCfParent(issue.key, 0);
							} else if(imgUrl.endsWith('/minus.png')) {
								AJS.$(this).attr('src', AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/plus.png')
								removeRowsCfParent(issue.key);
							}
						}
					}).addClass('synapse-parents-img-tag')
				).addClass('synapse-custom-cf-issue-item-left-icon')
			);
		}

		var input = AJS.$('<input/>', {
			type: 'radio',
			name: 'selecteParent',
			click: function() {
				if(AJS.$(this).is(':checked')) {
					selectedCfParent(AJS.$(this));
				}
			}
		});

		if(issue.key == AJS.$('#CfParent').val())
			input.attr('checked', 'checked');
		widget.append(issue.key, 
				AJS.$('<div/>').addClass(issueItemRightIconClassCfParent).append(input),
				AJS.$('<div/>').addClass(issueItemSummaryContainerClassCfParent).append(AJS.$('<p/>').text(issue.summary)));
		content.append(widget);
	}else{
		var widget = AJS.$('<div/>').addClass('synapse-parents-widget synapse-parents-table-cell');

		var widgetNavigation = AJS.$('<div/>').addClass('synapse-parents-widget-navigation').css('background-color', issue.issuetypecolor);

		if(issue.isExistsChilds) {
			widgetNavigation.append(AJS.$('<div/>').addClass('synapse-parents-left-icon').append(AJS.$('<img/>', {
				src: AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/plus.png',
				click: function() {
					var imgUrl = AJS.$(this).attr('src');
					if(imgUrl.endsWith('/plus.png')) {
						AJS.$(this).attr('src', AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/minus.png')
						loadParentCfParent(issue.key, 0);
					} else if(imgUrl.endsWith('/minus.png')) {
						AJS.$(this).attr('src', AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/plus.png')
						removeRowsCfParent(issue.key);
					}
				}
			}).addClass('synapse-parents-img-tag')));
		}

		var input = AJS.$('<input/>', {
			type: 'radio',
			name: 'selecteParent',
			click: function() {
				if(AJS.$(this).is(':checked')) {
					selectedCfParent(AJS.$(this));
				}
			}
		});

		if(issue.key == AJS.$('#CfParent').val())
			input.attr('checked', 'checked');

		widgetNavigation.append(AJS.$('<div/>').addClass('synapse-parents-right-text-icon').append(input));

		widget.append(widgetNavigation);

		var widgetSummary = AJS.$('<div/>', {
			title: issue.summary
		}).addClass(issueItemSummaryContainerClassCfParent + ' ' + getClassColorInfo(issue.state)).append(AJS.$('<p/>').text(issue.summary));

		widget.append(widgetSummary);

var widgetKey = "";
		if(issue.status=="Closed"){
			 widgetKey = AJS.$('<div/>').addClass('synapse-parents-widget-key ' + getClassColorKey(issue.status)).text(issue.key);
		}else{
			 widgetKey = AJS.$('<div/>').addClass('synapse-parents-widget-key ' + getClassColorKey(issue.state)).text(issue.key);
		}


		widget.append(widgetKey);

		content.append(widget);
	}
    return content;
}

function removeRowsCfParent(key) {
    AJS.$('#treeTable_CfParent').find('div[parent="' + key + '"]').each(function() {
        removeRowsCfParent(AJS.$(this).attr('key'));
        AJS.$(this).parents('tr.row').remove();
    });
}

function loadChildByPageCfParent(params) {
    var currentPage = AJS.$('div#' + params[0]).attr('currentpage');
    loadParentCfParent(params[1], parseInt(currentPage, 10) - 1);
}

function loadParentCfParent(parentKey, pageId) {
	synapseCustomDesignCfParent = AJS.$('#synapseCustomDesignCfParent').val();
	issueItemSummaryContainerClassCfParent = "synapse-parents-widget-info";
	issueItemWrapperClassCfParent = "synapse-parents-wrapper-table";
	issueItemRightIconClassCfParent = "synapse-parents-right-text-icon";
	if(synapseCustomDesignCfParent == "true"){
		issueItemSummaryContainerClassCfParent = "synapse-cf-issue-item-summary";
		issueItemWrapperClassCfParent = "synapse-custom-cf-issue-item-wrapper";
		issueItemRightIconClassCfParent = "synapse-custom-cf-issue-item-right-icon";
	}
	if(!AJS.$('#cfpProjectId').val() || 
			!AJS.$('#cfpProjectId').val().length || 
			!AJS.$('#cfpIssueType').val() || 
			!AJS.$('#cfpIssueType').val().length || 
			!AJS.$('#cfpCustomFieldId').val() ||
			!AJS.$('#cfpCustomFieldId').val().length){
		console.log("--->loadParentCfParent: Inappropriate values, quit");
		return;
	}

    removeRowsCfParent(parentKey);

    var data = 'projectId=' + AJS.$('#cfpProjectId').val()
             + '&issueTypeId=' + AJS.$('#cfpIssueType').val()
             + '&issueKey=' + AJS.$('#cfpIssueKey').val()
             + '&pageId=' + pageId
             + '&parentKey=' + parentKey
             + '&customFieldId=' + AJS.$('#cfpCustomFieldId').val();
    var url = AJS.contextPath() + '/plugins/servlet/';
    var cfpIssueType = AJS.$('#cfpIssueType').val();
    if(cfpIssueType == 'req') {
        url = url + 'requirementEdit';
    } else if(cfpIssueType == 'tc') {
        url = url + 'testCaseEdit';
    }else{
		console.log("SYNAPSE ERROR: Unable to define the issue type at Parent cf");
		return;
	}
    AJS.$.ajax({
        url: url,
        async: false,
        type: 'POST',
        data: data,
        success: function(result) {
            var obj = JSON.parse(result);

            var treeTable = AJS.$('#treeTable_CfParent');
            var trParent;
            var trData;
            var tdData;

            if(obj.issues) {
                var aIssues = obj.issues;

                for(var i = 0; i < aIssues.length; i++) {
                    trData = AJS.$('<tr/>').addClass('row');
                    tdData = AJS.$('<td/>').css('padding', '0px');
                    tdData.append(getContentForIssueCfParent(aIssues[i], parentKey));

                    trData.append(tdData);

                    if(parentKey == 'root') {
                        treeTable.append(trData);
                    } else {
                        trParent = treeTable.find('div[parent="' + parentKey + '"]:last').parents('tr.row');
                        if(!trParent.length) {
                            trParent = treeTable.find('div[key="' + parentKey + '"]').parents('tr.row');
                        }

                        trParent.after(trData);
                    }

                    truncateText(AJS.$('div[key="' + aIssues[i].key + '"] .' + issueItemSummaryContainerClassCfParent));
                }
            }

            if (obj.pages && parseInt(obj.pages, 10) > 1) {
                var params = [];
                params[0] = parentKey + '-paginator-com-go2group-jira-plugin-synapse-parent-cf';
                params[1] = parentKey;

                var paginatorEl = AJS.$('<div/>', {
                    id: params[0],
                    currentpage: '',
                    totalpages: obj.pages,
                    parent: parentKey
                }).addClass('synapse-parents-pager');

                trData = AJS.$('<tr/>').addClass('row');
                tdData = AJS.$('<td/>').css('padding', '0px');
                tdData.append(paginatorEl);

                trData.append(tdData);

                if(parentKey == 'root') {
                    treeTable.append(trData);
                } else {
                    trParent = treeTable.find('div[parent="' + parentKey + '"]:last').parents('tr.row');
                    if(!trParent.length) {
                        trParent = treeTable.find('div[key="' + parentKey + '"]').parents('tr.row');
                    }

                    trParent.after(trData);
                }

                paginator(params[0], parseInt(pageId, 10) + 1, obj.pages, 5, loadChildByPageCfParent, 'child', params);
            }
        }
    });
}

AJS.$('#RP-CfParent').live('click', function() {
    loadParentCfParent('root', 0);
});

AJS.$('#CS-CfParent').live('click', function() {
    AJS.$('#selected-CfParent').empty();
    AJS.$('#CfParent').val('');
    AJS.$('#treeTable_CfParent').find(':radio:checked').removeAttr('checked');
});

function load_CfParent() {
    loadParentCfParent('root', 0);

    var selected = AJS.$('#selected-CfParent').find('.synapse-parents-widget');
    if(selected.length)
        truncateText(selected.find('.' + issueItemSummaryContainerClassCfParent));
}