var synapseCustomDesignCfReq = AJS.$('#synapseCustomDesignCfReq').val();

var issueItemSummaryContainerClassCfReq = "synapse-parents-widget-info";
var issueItemWrapperClassCfReq = "synapse-parents-wrapper-table";
var issueItemRightIconClassCfReq = "synapse-parents-right-text-icon";
if(synapseCustomDesignCfReq == "true"){
	issueItemSummaryContainerClassCfReq = "synapse-cf-issue-item-summary";
	issueItemWrapperClassCfReq = "synapse-custom-cf-issue-item-wrapper";
	issueItemRightIconClassCfReq = "synapse-custom-cf-issue-item-right-icon";
}

function removeRowsCfReq(key) {
    AJS.$('#treeTable_CfReq').find('div[parent="' + key + '"]').each(function() {
        removeRowsCfReq(AJS.$(this).attr('key'));
        AJS.$(this).parents('tr.row').remove();
    });
}

function getContentForIssueCfReq(issue, parent) {
    var content = AJS.$('<div/>', {
        id: issue.id,
        key: issue.key,
        parent: parent
    });
	
	content.addClass(issueItemWrapperClassCfReq);

    var n = parseInt(issue.level, 10);
    var spacer;
    for(var i = 0; i < n; i++) {
        spacer = AJS.$('<div/>')
				.addClass('synapse-parents-tree-spacer synapse-parents-table-cell')
				.append('&nbsp;');

        if(i == n - 1) {
            spacer.append(AJS.$('<img/>', {
                src: AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/up_to_right_arrow.png'
            }).addClass('synapse-parents-img-tag'));
        }

        content.append(spacer);
    }
	if(synapseCustomDesignCfReq == "true"){
		var widget = AJS.$('<div/>').addClass('synapse-custom-cf-issue-item-widget');
		
		
		if(issue.isExistsChilds){
			var plusContainer = AJS.$('<div/>');
			widget.append(
				plusContainer.append(				
					AJS.$('<img/>', {
						src: AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/plus.png',
						click: function() {
							var imgUrl = AJS.$(this).attr('src');
							if(imgUrl.endsWith('/plus.png')) {
								AJS.$(this).attr('src', AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/minus.png')
								loadRequirementCfReq(issue.key, 0);
							} else if(imgUrl.endsWith('/minus.png')) {
								AJS.$(this).attr('src', AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/plus.png')
								removeRowsCfReq(issue.key);
							}
						}
					}).addClass('synapse-parents-img-tag')
				).addClass('synapse-custom-cf-issue-item-left-icon')
			);
			/* This is needed for TC cf only.
			var loadChildContainer = AJS.$('<div/>');
			widget.append(
				loadChildContainer.append(				
					AJS.$('<img/>', {
						src: AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/full_info.png',
						click: function() {
							addChildsCfTc(issue.key);
						}
					}).addClass('synapse-parents-img-tag')
				).addClass('synapse-custom-cf-issue-item-right-icon-img')
			);
			*/
		}
		var input = AJS.$('<input/>', {
			type: 'checkbox'
		});
		widget.append(issue.key, 
				AJS.$('<div/>').addClass(issueItemRightIconClassCfReq).append(input),
				AJS.$('<div/>').addClass(issueItemSummaryContainerClassCfReq).append(AJS.$('<p/>').text(issue.summary)));
		content.append(widget);
	}else{
		var widget = AJS.$('<div/>').addClass('synapse-parents-widget synapse-parents-table-cell');

		var widgetNavigation = AJS.$('<div/>').addClass('synapse-parents-widget-navigation').css('background-color', issue.issuetypecolor);

		if(issue.isExistsChilds) {
			widgetNavigation.append(AJS.$('<div/>').addClass('synapse-parents-left-icon').append(AJS.$('<img/>', {
				src: AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/plus.png',
				click: function() {
					var imgUrl = AJS.$(this).attr('src');
					if(imgUrl.endsWith('/plus.png')) {
						AJS.$(this).attr('src', AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/minus.png')
						loadRequirementCfReq(issue.key, 0);
					} else if(imgUrl.endsWith('/minus.png')) {
						AJS.$(this).attr('src', AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/plus.png')
						removeRowsCfReq(issue.key);
					}
				}
			}).addClass('synapse-parents-img-tag')));
		}

		var input = AJS.$('<input/>', {
			type: 'checkbox'
		});

		if(issue.key == AJS.$('#CfReq').val())
			input.attr('checked', 'checked');

		widgetNavigation.append(AJS.$('<div/>').addClass(issueItemRightIconClassCfReq).append(input));

		widget.append(widgetNavigation);

		var widgetSummary = AJS.$('<div/>', {
			title: issue.summary
		}).addClass(issueItemSummaryContainerClassCfReq + ' ' + getClassColorInfo(issue.state)).append(AJS.$('<p/>').text(issue.summary));

		widget.append(widgetSummary);
		var widgetKey = "";
if(issue.status=="Closed"){
			 widgetKey = AJS.$('<div/>').addClass('synapse-parents-widget-key ' + getClassColorKey(issue.status)).text(issue.key);
		}else{
			 widgetKey = AJS.$('<div/>').addClass('synapse-parents-widget-key ' + getClassColorKey(issue.state)).text(issue.key);
		}


		widget.append(widgetKey);

		content.append(widget);
	}

    return content;
}

function loadChildByPageCfReq(params) {
    var currentPage = AJS.$('div#' + params[0]).attr('currentpage');
    loadRequirementCfReq(params[1], parseInt(currentPage, 10) - 1);
	AJS.$('#AllItemsCfReq').attr('checked', false);
}

function loadRequirementCfReq(parentKey, pageId) {
	synapseCustomDesignCfReq = AJS.$('#synapseCustomDesignCfReq').val();
	issueItemSummaryContainerClassCfReq = "synapse-parents-widget-info";
	issueItemWrapperClassCfReq = "synapse-parents-wrapper-table";
	issueItemRightIconClassCfReq = "synapse-parents-right-text-icon";
	if(synapseCustomDesignCfReq == "true"){
		issueItemSummaryContainerClassCfReq = "synapse-cf-issue-item-summary";
		issueItemWrapperClassCfReq = "synapse-custom-cf-issue-item-wrapper";
		issueItemRightIconClassCfReq = "synapse-custom-cf-issue-item-right-icon";
	}
    removeRowsCfReq(parentKey);
	if(!AJS.$('#synapse-cfr-project-select').val() || 
			!AJS.$('#synapse-cfr-project-select').val().length ||
			!AJS.$('#cfrIssueType').val() || 
			!AJS.$('#cfrIssueType').val().length || 
			!AJS.$('#cfrCustomFieldId').val() || 
			!AJS.$('#cfrCustomFieldId').val().length){
		console.log("--->loadRequirementCfReq: Inappropriate values, quit");
		return;
	}
		
    var data = 'projectId=' + AJS.$('#synapse-cfr-project-select').val() + '&issueTypeId=' + AJS.$('#cfrIssueType').val() + '&issueKey=' + AJS.$('#cfrIssueKey').val() + '&pageId=' + pageId + '&parentKey=' + parentKey + '&customFieldId=' + AJS.$('#cfrCustomFieldId').val();
	
	console.log("--->loadRequirementCfReq with data " + data);
    AJS.$.ajax({
        url: AJS.contextPath() + '/plugins/servlet/requirementEdit',
        async: false,
        type: 'POST',
        data: data,
        success: function(result) {
            var obj = JSON.parse(result);
            var aIssues = obj.issues;

            var treeTable = AJS.$('#treeTable_CfReq');
            var trData;
            var tdData;

            if(obj.issues) {
                var aIssues = obj.issues;

                for(var i = 0; i < aIssues.length; i++) {
                    trData = AJS.$('<tr/>').addClass('row');
                    tdData = AJS.$('<td/>').css('padding', '0px');
                    tdData.append(getContentForIssueCfReq(aIssues[i], parentKey));

                    trData.append(tdData);

                    if(parentKey == 'root') {
                        treeTable.append(trData);
                    } else {
                        trParent = treeTable.find('div[parent="' + parentKey + '"]:last').parents('tr.row');
                        if(!trParent.length) {
                            trParent = treeTable.find('div[key="' + parentKey + '"]').parents('tr.row');
                        }

                        trParent.after(trData);
                    }

                    truncateText(AJS.$('div[key="' + aIssues[i].key + '"] .' + issueItemSummaryContainerClassCfReq));
                }
            }

            if (obj.pages && parseInt(obj.pages, 10) > 1) {
                var params = [];
                params[0] = parentKey + '-paginator-com-go2group-jira-plugin-synapse-requirement-cf';
                params[1] = parentKey;

                var paginatorEl = AJS.$('<div/>', {
                    id: params[0],
                    currentpage: '',
                    totalpages: obj.pages,
                    parent: parentKey
                }).addClass('synapse-parents-pager');

                trData = AJS.$('<tr/>').addClass('row');
                tdData = AJS.$('<td/>').css('padding', '0px');
                tdData.append(paginatorEl);

                trData.append(tdData);

                if(parentKey == 'root') {
                    treeTable.append(trData);
                } else {
                    trParent = treeTable.find('div[parent="' + parentKey + '"]:last').parents('tr.row');
                    if(!trParent.length) {
                        trParent = treeTable.find('div[key="' + parentKey + '"]').parents('tr.row');
                    }

                    trParent.after(trData);
                }

                paginator(params[0], parseInt(pageId, 10) + 1, obj.pages, 5, loadChildByPageCfReq, 'child', params);
				AJS.$('#treeTable_CfReq input').each(function() {
					AJS.$(this).bind('click', function() {
						verifyCheckboxesCfReq('AllItemsCfReq','treeTable_CfReq');
					});
				});
            }
        }
    });
}

function addItemsCfReq() {
    var tdData = AJS.$('#selected-CfReq');
    var selectedWidget;
    AJS.$('#treeTable_CfReq').find(':checkbox:checked').each(function() {

        if(!AJS.$('#selected-CfReq').children('div#' + AJS.$(this).parents('div.' + issueItemWrapperClassCfReq).attr('id') + '.' + issueItemWrapperClassCfReq).length) {
            AJS.$(this).parents('div.' + issueItemWrapperClassCfReq).clone().appendTo(tdData);

            selectedWidget = tdData.children('div.' + issueItemWrapperClassCfReq + ':last-child');
            selectedWidget.find('.synapse-parents-tree-spacer').remove();
            selectedWidget.find('.synapse-parents-left-icon').remove();
            selectedWidget.find('.' + issueItemRightIconClassCfReq + ' :checkbox').removeAttr('checked');
            truncateText(selectedWidget.find('.' + issueItemSummaryContainerClassCfReq));

            AJS.$('#CfReq').append(AJS.$('<option/>', {
                selected: 'selected'
            }).val(AJS.$(this).parents('div.' + issueItemWrapperClassCfReq).attr('id')));
        }

        AJS.$(this).removeAttr('checked');
    });
	
	AJS.$('#selected-CfReq input').each(function() {
		AJS.$(this).bind('click', function() {
			verifyCheckboxesCfReq('AllItemsCfReqSelected', 'selected-CfReq');
		});
	});
	AJS.$('#AllItemsCfReq').attr('checked', false);
	AJS.$('#AllItemsCfReqSelected').attr('checked', false);
}

function removeItemsCfReq() {
    AJS.$('#selected-CfReq').find(':checkbox:checked').each(function() {
        AJS.$('#CfReq').children('option[value="' + AJS.$(this).parents('div.' + issueItemWrapperClassCfReq).attr('id') + '"]').remove();
        AJS.$(this).parents('div.' + issueItemWrapperClassCfReq).remove();
    });
	AJS.$('#AllItemsCfReq').attr('checked', false);
	AJS.$('#AllItemsCfReqSelected').attr('checked', false);
}

AJS.$('#RP-CfReq').live('click', function() {
    loadRequirementCfReq('root', 0);
});

AJS.$('#CS-CfReq').live('click', function() {
    AJS.$('#selected-CfReq').empty();
    AJS.$('#CfReq').empty();
    AJS.$('#treeTable_CfReq').find(':checkbox:checked').removeAttr('checked');
});

AJS.$('img[src$="/button_right.png"][CfReq]').live('click', function() {
    loadRequirementCfReq('root', 0);
});

AJS.$('#RP-CfReq').live('click', function() {
    loadRequirementCfReq('root', 0);
});


function load_CfReq() {
    loadRequirementCfReq('root', 0);

    AJS.$('#selected-CfReq .' + issueItemSummaryContainerClassCfReq).each(function() {
        truncateText(AJS.$(this));
    });
}

function selectAllItemsCfReq(){
    AJS.$('#treeTable_CfReq input').each(function() {
		if(AJS.$('#AllItemsCfReq').attr('checked'))
			AJS.$(this).attr('checked', true);
		else
			AJS.$(this).attr('checked', false);
    });
	AJS.$('#selected-CfReq input').each(function() {
		if(AJS.$('#AllItemsCfReqSelected').attr('checked'))
			AJS.$(this).attr('checked', true);
		else
			AJS.$(this).attr('checked', false);
    });
}

function verifyCheckboxesCfReq(buttonId, checkboxContainerId){
	var check = true;
	AJS.$('#'+checkboxContainerId+' input').each(function() {
		if(!AJS.$(this).attr('checked')){
			check = false;
			return false;
		}
    });
	if(check)
		AJS.$('#'+buttonId).attr('checked', true);
	else
		AJS.$('#'+buttonId).attr('checked', false);
}