var synapseCustomDesignCfTc = AJS.$('#synapseCustomDesignCfTc').val();

var issueItemSummaryContainerClassCfTc = "synapse-parents-widget-info";
var issueItemWrapperClassCfTc = "synapse-parents-wrapper-table";
var issueItemRightIconClassCfTc = "synapse-parents-right-text-icon";

var itemsPerPageCfTc =  parseInt(AJS.$('#cftcItemsPerPage').val(), 10);
var currentPageCfTc = 1;
var originalOptionsSizeCfTc = 0;
var paginatorDivIdCfTc = 'paginator-com-go2group-jira-plugin-tc-cf-edit';
var currentOptionsCfTc = {};
var currentPageOptionsCfTc = '';
if(synapseCustomDesignCfTc == "true"){
	issueItemSummaryContainerClassCfTc = "synapse-cf-issue-item-summary";
	issueItemWrapperClassCfTc = "synapse-custom-cf-issue-item-wrapper";
	issueItemRightIconClassCfTc = "synapse-custom-cf-issue-item-right-icon";
}

function removeRowsCfTc(key) {
    AJS.$('#treeTable_CfTc').find('div[parent="' + key + '"]').each(function() {
        removeRowsCfTc(AJS.$(this).attr('key'));
        AJS.$(this).parents('tr.row').remove();
    });
}

function getTestSuiteCfTc() {
    var checkeds = AJS.$('#testSuiteList_CfTc').find(':selected');
    var testSuites = '';
    for (var i = 0; i < checkeds.length; i++) {
        testSuites += (i == 0 ? '' : ',') + checkeds[i].value;
    }
    return testSuites;
}

//
function getContentForIssueCfTc(issue, parent) {
	console.log("--->getContentForIssueCfTc");
    var content = AJS.$('<div/>', {
        'id': issue.id,
        'key': issue.key,
        'parent': parent
    });
	
	content.addClass(issueItemWrapperClassCfTc);

    var n = parseInt(issue.level, 10);
    var spacer;
    for(var i = 0; i < n; i++) {
        spacer = AJS.$('<div/>')
				.addClass('synapse-parents-tree-spacer synapse-parents-table-cell')
				.append('&nbsp;');

        if(i == n - 1) {
            spacer.append(AJS.$('<img/>', {
                'src': AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/up_to_right_arrow.png'
            }).addClass('synapse-parents-img-tag'));
        }

        content.append(spacer);
    }
	if(synapseCustomDesignCfTc == "true"){
		var widget = AJS.$('<div/>').addClass('synapse-custom-cf-issue-item-widget');
		

		if(AJS.$(':radio[name="view"]:checked').val() == 'tree' && issue.isExistsChilds) {
			var plusContainer = AJS.$('<div/>');
			widget.append(
				plusContainer.append(				
					AJS.$('<img/>', {
						'src': AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/plus.png',
						'click': function() {
							var imgUrl = AJS.$(this).attr('src');
							if(imgUrl.endsWith('/plus.png')) {
								AJS.$(this).attr('src', AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/minus.png')
								loadTestCaseCfTc(issue.key, 0);
							} else if(imgUrl.endsWith('/minus.png')) {
								AJS.$(this).attr('src', AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/plus.png')
								removeRowsCfTc(issue.key);
							}
						}
					}).addClass('synapse-parents-img-tag')
				).addClass('synapse-custom-cf-issue-item-left-icon')
			);
			var loadChildContainer = AJS.$('<div/>');
			widget.append(
				loadChildContainer.append(				
					AJS.$('<img/>', {
						'src': AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/full_info.png',
						'click': function() {
							addChildsCfTc(issue.key);
						}
					}).addClass('synapse-parents-img-tag')
				).addClass('synapse-custom-cf-issue-item-right-icon-img')
			);
		}
		var input = AJS.$('<input/>', {
			'type': 'checkbox'
		});
		widget.append(issue.key, 
				AJS.$('<div/>').addClass(issueItemRightIconClassCfTc).append(input),
				AJS.$('<div/>').addClass(issueItemSummaryContainerClassCfTc).append(AJS.$('<p/>').text(issue.summary)));
	
content.append(widget);
	}else{
		var widget = AJS.$('<div/>').addClass('synapse-parents-widget synapse-parents-table-cell');
	
		var widgetNavigation = AJS.$('<div/>').addClass('synapse-parents-widget-navigation').css('background-color', issue.issuetypecolor);

		if(AJS.$(':radio[name="view"]:checked').val() == 'tree' && issue.isExistsChilds) {
			widgetNavigation.append(AJS.$('<div/>').addClass('synapse-parents-left-icon').append(AJS.$('<img/>', {
				'src': AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/plus.png',
				'click': function() {
					var imgUrl = AJS.$(this).attr('src');
					if(imgUrl.endsWith('/plus.png')) {
						AJS.$(this).attr('src', AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/minus.png')
						loadTestCaseCfTc(issue.key, 0);
					} else if(imgUrl.endsWith('/minus.png')) {
						AJS.$(this).attr('src', AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/plus.png')
						removeRowsCfTc(issue.key);
					}
				}
			}).addClass('synapse-parents-img-tag')));
			
			var loadChildContainer = AJS.$('<div/>');
			widgetNavigation.append(
				loadChildContainer.append(				
					AJS.$('<img/>', {
						'src': AJS.contextPath() + '/download/resources/com.go2group.jira.plugin.synapse/includes/img/dashboard/full_info.png',
						'click': function() {
							addChildsCfTc(issue.key);
						}
					}).addClass('synapse-parents-img-tag')
				).addClass('synapse-parents-right-icon')
			);
		}

		var input = AJS.$('<input/>', {
			'type': 'checkbox'
		});

		if(issue.key == AJS.$('#CfTc').val())
			input.attr('checked', 'checked');

		widgetNavigation.append(AJS.$('<div/>').addClass(issueItemRightIconClassCfTc).append(input));

		widget.append(widgetNavigation);

		var widgetSummary = "";
		if(issue.status=="Closed"){
			 widgetSummary = AJS.$('<div/>', {
				'title': issue.summary
			}).addClass(issueItemSummaryContainerClassCfTc + ' ' + getClassColorInfo("Closed")).append(AJS.$('<p/>').text(issue.summary));
		}else{
			 widgetSummary = AJS.$('<div/>', {
				'title': issue.summary
			}).addClass(issueItemSummaryContainerClassCfTc + ' ' + getClassColorInfo(issue.state)).append(AJS.$('<p/>').text(issue.summary));
		}
		widget.append(widgetSummary);
		var widgetKey = AJS.$('<div/>');
		if(issue.status=="Closed"){
			 widgetKey = widgetKey.addClass('synapse-parents-widget-key ' + getClassColorKey('Closed')).text(issue.key);
		}else{
			 widgetKey = widgetKey.addClass('synapse-parents-widget-key ' + getClassColorKey(issue.state)).text(issue.key);
		}

		widget.append(widgetKey);

		content.append(widget);
	}

	console.log("<---getContentForIssueCfTc");
    return content;
}

function loadChildByPageCfTc(params) {
    var currentPage = AJS.$('div#' + params[0]).attr('currentpage');
    loadTestCaseCfTc(params[1], parseInt(currentPage, 10) - 1);
    AJS.$('#AllItemsCfTc').attr('checked', false);
}

//
function loadTestCaseCfTc(parentKey, pageId) {
	console.log("--->loadTestCaseCfTc");
	
	if(!AJS.$('#synapse-cftc-project-select').val() || 
			!AJS.$('#synapse-cftc-project-select').val().length ||
			!AJS.$('#cftcIssueType').val() || 
			!AJS.$('#cftcIssueType').val().length || 
			!AJS.$('#cftcCustomFieldId').val() || 
			!AJS.$('#cftcCustomFieldId').val().length){
		console.log("--->loadTestCaseCfTc: Inappropriate values, quit");
		return;
	}
	
	synapseCustomDesignCfTc = AJS.$('#synapseCustomDesignCfTc').val();
	issueItemSummaryContainerClassCfTc = "synapse-parents-widget-info";
	issueItemWrapperClassCfTc = "synapse-parents-wrapper-table";
	issueItemRightIconClassCfTc = "synapse-parents-right-text-icon";
	if(synapseCustomDesignCfTc == "true"){
		issueItemSummaryContainerClassCfTc = "synapse-cf-issue-item-summary";
		issueItemWrapperClassCfTc = "synapse-custom-cf-issue-item-wrapper";
		issueItemRightIconClassCfTc = "synapse-custom-cf-issue-item-right-icon";
	}
    removeRowsCfTc(parentKey);

    var data = 'view=' + AJS.$(':radio[name="view"]:checked').val()
             + '&projectId=' + AJS.$('#synapse-cftc-project-select').val()
             + '&issueTypeId=' + AJS.$('#cftcIssueType').val()
             + '&issueKey=' + AJS.$('#cftcIssueKey').val()
             + '&pageId=' + pageId
             + '&parentKey=' + parentKey
             + '&customFieldId=' + AJS.$('#cftcCustomFieldId').val()
             + '&filter=' + AJS.$('#filter_CfTc').val()
             + '&testSuite=' + getTestSuiteCfTc()
             + '&numberTcToLoad=' + AJS.$('#numberTcToLoad').val();
	console.log('load test cases: ' + data);
    AJS.$.ajax({
        url: AJS.contextPath() + '/plugins/servlet/testCaseEdit',
        async: true,
        type: 'POST',
        data: data,
        success: function(result) {
            var obj = JSON.parse(result);
            var aIssues = obj.issues;

            var treeTable = AJS.$('#treeTable_CfTc');
            var trData;
            var tdData;

            if(obj.issues) {
                var aIssues = obj.issues;

                for(var i = 0; i < aIssues.length; i++) {
					console.log('create item html for : ' + JSON.stringify(aIssues[i]));
                    
					trData = AJS.$('<tr/>').addClass('row');
                    tdData = AJS.$('<td/>').css('padding', '0px');
					console.log("append item " + aIssues[i].key);
                    tdData.append(getContentForIssueCfTc(aIssues[i], parentKey));

					console.log("append item container ");
                    trData.append(tdData);

                    if(parentKey == 'root') {
						console.log("root issue ");
                        treeTable.append(trData);
                    } else {
						console.log("child issue, search for parent");
                        trParent = treeTable.find('div[parent="' + parentKey + '"]:last').parents('tr.row');
                        if(!trParent.length) {
							console.log("parent not found");
                            trParent = treeTable.find('div[key="' + parentKey + '"]').parents('tr.row');
                        }
						
						console.log("append issue table row ");
                        trParent.after(trData);
                    }
					
					console.log("truncate text ");
                    truncateText(AJS.$('div[key="' + aIssues[i].key + '"] .' + issueItemSummaryContainerClassCfTc));
                }
            }
            
            console.log("pages count --> "+obj.pages);

            if (obj.pages && parseInt(obj.pages, 10) > 1) {
                var params = [];
                params[0] = parentKey + '-paginator-com-go2group-jira-plugin-synapse-testcase-cf';
                params[1] = parentKey;

                var paginatorEl = AJS.$('<div/>', {
                    'id': params[0],
                    'currentpage': '',
                    'totalpages': obj.pages,
                    'parent': parentKey
                }).addClass('synapse-parents-pager');

                trData = AJS.$('<tr/>').addClass('row');
                tdData = AJS.$('<td/>').css('padding', '0px');
                tdData.append(paginatorEl);

                trData.append(tdData);

                if(parentKey == 'root') {
                    treeTable.append(trData);
                } else {
                    trParent = treeTable.find('div[parent="' + parentKey + '"]:last').parents('tr.row');
                    if(!trParent.length) {
                        trParent = treeTable.find('div[key="' + parentKey + '"]').parents('tr.row');
                    }

                    trParent.after(trData);
                }

                paginator(params[0], parseInt(pageId, 10) + 1, obj.pages, 5, loadChildByPageCfTc, 'child', params);
                AJS.$('#treeTable_CfTc input').each(function() {
					AJS.$(this).bind('click', function() {
						verifyCheckboxesCfTc('AllItemsCfTc','treeTable_CfTc');
					});
				});
            }
        }
    });
	console.log("<---loadTestCaseCfTc");
}

//
function addItemsCfTc() {
    var tdData = AJS.$('#selected-CfTc');
    var selectedWidget;
	var added = 0;
    AJS.$('#treeTable_CfTc').find(':checkbox:checked').each(function() {
		var issueItemId = AJS.$(this).parents('div.' + issueItemWrapperClassCfTc).attr('id');
		
		if(!AJS.$('#CfTc').children('option[value="' + issueItemId + '"]').length){
            
            AJS.$('#CfTc').append(AJS.$('<option/>', {
                'selected': 'selected'
            }).val(issueItemId));
			
			currentOptionsCfTc[issueItemId] = '1';
			
			if(AJS.$('#selected-CfTc').children('div#' + issueItemId + '.' + issueItemWrapperClassCfTc).length){
				AJS.$('#selected-CfTc').children('div#' + issueItemId + '.' + issueItemWrapperClassCfTc).css({'opacity':'1'});
				AJS.$(this).removeAttr("disabled");
			}
			added++;
        }

        AJS.$(this).removeAttr('checked');
    });
	console.log(currentOptionsCfTc);
	var msg = "Added " + added + " issue";
	if(added!=1)
		msg += "s";
	AJS.$('#cfTcAddedMsg').text(msg);
	paginationManager(true);
	loadTestCasesCfTcEdit();
	
	AJS.$('#selected-CfTc input').each(function() {
		AJS.$(this).bind('click', function() {
			verifyCheckboxesCfTc('AllItemsCfTcSelected', 'selected-CfTc');
		});
	});
	AJS.$('#AllItemsCfTc').attr('checked', false);
	AJS.$('#AllItemsCfTcSelected').attr('checked', false);
    
}

//
function removeItemsCfTc() {
	var removed = 0;
    AJS.$('#selected-CfTc').find(':checkbox:checked').each(function() {
		var issueItemId = AJS.$(this).parents('div.' + issueItemWrapperClassCfTc).attr('id');
        AJS.$('#CfTc').children('option[value="' + issueItemId + '"]').remove();
		
		if(currentOptionsCfTc[issueItemId])
			delete currentOptionsCfTc[issueItemId];
		removed++;
        AJS.$(this).parents('div.' + issueItemWrapperClassCfTc).css({'opacity':'0.3'});
		AJS.$(this).attr("disabled", true);
		AJS.$(this).parents('div.' + issueItemWrapperClassCfTc).find('.' + issueItemRightIconClassCfTc + ' :checkbox').removeAttr('checked');
    });
	
	var msg = "Removed " + removed + " issue";
	if(removed!=1)
		msg += "s";
	AJS.$('#cfTcAddedMsg').text(msg);
	console.log(currentOptionsCfTc);
	AJS.$('#AllItemsCfTc').attr('checked', false);
	AJS.$('#AllItemsCfTcSelected').attr('checked', false);
	paginationManager();
	loadTestCasesCfTcEdit();
}
AJS.$('#filter').live('click', function() {
	if(AJS.$('#cfTcView > :radio[name="view"]').val() == 'tree') {
		AJS.$('#cfTcView > :radio[value="tree"]').removeAttr('checked');
	AJS.$('#cfTcView > :radio[value="line"]').attr('checked', true).trigger('click');
	}
});

//
AJS.$('#query-CfTc').live('click', function() {
    loadTestCaseCfTc('root', 0);
});

//
AJS.$('#cfTcView > :radio[name="view"]').live('change', function() {
    if(AJS.$(this).is(':checked'))
        if(AJS.$(this).val() == 'line') {
            AJS.$('#filter').show();
        } else if(AJS.$(this).val() == 'tree') {
            AJS.$('#filter').hide();
        }
    loadTestCaseCfTc('root', 0);
});

//
function load_CfTc() {
	console.log("--->load_CfTc");
    loadTestCaseCfTc('root', 0);

    AJS.$('#selected-CfTc .'+issueItemSummaryContainerClassCfTc).each(function() {
        truncateText(AJS.$(this));
    });
	currentPageCfTc = 1;
	originalOptionsSizeCfTc = 0;
	currentOptionsCfTc = {};
	currentPageOptionsCfTc = '';
	 AJS.$('#CfTc').children('option').each(
		function(){
			currentOptionsCfTc[AJS.$(this).val()] = '1';
		}
	 );
	console.log('current cf tc: ' + currentOptionsCfTc);
	originalOptionsSizeCfTc = synapseSizeTcCf(currentOptionsCfTc);
	itemsPerPageCfTc =  parseInt(AJS.$('#cftcItemsPerPage').val(), 10);
			
	paginationManager();
	
	if(AJS.$('#selected-CfTc').length)
		loadTestCasesCfTcEdit();
	console.log("<---load_CfTc");
}

//
function selectAllItemsCfTc(){
    AJS.$('#treeTable_CfTc input').each(function() {
		if(AJS.$('#AllItemsCfTc').attr('checked'))
			AJS.$(this).attr('checked', true);
		else
			AJS.$(this).attr('checked', false);
    });
	AJS.$('#selected-CfTc input').each(function() {
		if(AJS.$('#AllItemsCfTcSelected').attr('checked'))
			AJS.$(this).attr('checked', true);
		else
			AJS.$(this).attr('checked', false);
    });
}

//
function verifyCheckboxesCfTc(buttonId, checkboxContainerId){
	var check = true;
	AJS.$('#'+checkboxContainerId+' input').each(function() {
		if(!AJS.$(this).attr('checked')){
			check = false;
			return false;
		}
    });
	if(check)
		AJS.$('#'+buttonId).attr('checked', true);
	else
		AJS.$('#'+buttonId).attr('checked', false);
}

function addChildsCfTc(key){
	var tdData = AJS.$('#selected-CfTc');
	ChangeChildsScreen.run().then(
		function(){
			setTimeout( function(){	
				var intervalId;
				intervalId = setInterval(function() {
					var data = 'view=childs'
						 + '&projectId=' + AJS.$('#synapse-cftc-project-select').val()
						 + '&issueTypeId=' + AJS.$('#cftcIssueType').val()
						 + '&pageId=none'
						 + '&parentKey=' + key
						 + '&customFieldId=' + AJS.$('#cftcCustomFieldId').val();
					console.log('loading childs: ' + data);
					AJS.$.ajax({
						url: AJS.contextPath() + '/plugins/servlet/testCaseEdit',
						async: true,
						type: 'POST',
						data: data,
						success: function(result) {
							console.log('got result ' + result);
							var obj = JSON.parse(result);
							if(obj.status){
								var status = obj.status;
								console.log('operation status: ' + status);
								if(status == 'pending'){
									console.log('operation progress ' + obj.progress);
									AJS.$('#synapse-tc-progress-bar-percent').text(obj.progress);
								}else if(status == 'finished'){
									if(obj.childs){
										var childs = obj.childs;
										var added = 0;
										console.log('got childs ' + childs);
										
										for(var i = 0; i < childs.length; i++) {
											console.log(childs[i]);
											currentOptionsCfTc[childs[i]] = '1';
											AJS.$('#CfTc').append(AJS.$('<option/>', {
												'selected': 'selected'
											}).val(childs[i]));
											added++;
										}
										paginationManager(true);
										loadTestCasesCfTcEdit();
										
										var msg = "Added " + added + " issue";
										if(added!=1)
											msg += "s";
										AJS.$('#cfTcAddedMsg').text(msg);
										AJS.$('#synapse-aui-blanket').hide();
										AJS.$('#synapse-progress-popup').hide();
									}else{
										console.log('no childs');
									}
									clearInterval(intervalId);
									
									AJS.$('#synapse-aui-blanket').hide();
									AJS.$('#synapse-progress-popup').hide();
								} else {
									console.log('no information on progress');
									clearInterval(intervalId);
									
									AJS.$('#synapse-aui-blanket').hide();
									AJS.$('#synapse-progress-popup').hide();
								}
							}
						}
					});
				
				}, 1000);
			},100);
		}
	);
}

ChangeChildsScreen = {
	run:function() {
		var dfr = AJS.$.Deferred();
		AJS.$('#synapse-aui-blanket').show();
		AJS.$('#synapse-progress-popup').show();
		AJS.$('#synapse-tc-progress-bar-percent').text('0');
		return dfr.resolve();
	}
}

function loadTestCasesCfTcEdit() {
	
	var tcCfContainer = AJS.$('#selected-CfTc');
	tcCfContainer.empty();
	
	var data = 'issueKey=' + AJS.$('#cftcIssueKey').val() 
			+ '&issueType=' + AJS.$('#cftcIssueType').val() + '&edit=true&ids=' + currentPageOptionsCfTc
			+ '&projectId=' + AJS.$('#synapse-cftc-project-select').val() + '&limit=' + itemsPerPageCfTc
			+ '&jiraAction=' + AJS.$('#cftcJiraAction').val();
	console.log('load tc data by ids: ' + data);
	AJS.$.ajax({
		url: AJS.contextPath() + '/plugins/servlet/testCaseCFServlet',
		async: true,
		type: 'POST',
		data: data,
		success: function(result){
			var obj = JSON.parse(result);
			var error = obj.error;
			if(error){
				AJS.$('#errors').append(
					AJS.$('<div/>').text(error)
				);
			}else{
				var issuesArray = obj.issues;
				itemsPerPageCfTc = obj.itemsPerPage;
				if(issuesArray) {
					tcCfContainer.empty();
					for(var i = 0; i < issuesArray.length; i++) {
						var issueItem = getContentForIssueCfTc(issuesArray[i],'none');
						issueItem.find('.synapse-parents-tree-spacer').remove();
						issueItem.find('.synapse-parents-left-icon').remove();
						issueItem.find('.synapse-custom-cf-issue-item-left-icon').remove();
						issueItem.find('.synapse-parents-right-icon').remove();
						issueItem.find('.synapse-custom-cf-issue-item-right-icon-img').remove();
						AJS.$(tcCfContainer).append(issueItem);
					}
				}
			}
		}
	});
	console.log('items added');
}

function paginatorHandlerCfTcEdit(paginatorDivIdCfTc){
	var pageId = AJS.$('#synapse-tc-cf-edit-paginator').find('.synapse-pager-small-button-selected').text();
	currentPageCfTc = parseInt(pageId, 10);
	paginationManager();
	loadTestCasesCfTcEdit();
}

function synapseSizeTcCf(obj) {
	console.log("counting size of " + obj);
    var size = 0;
    for (var key in obj) {
        if (obj.hasOwnProperty(key)) size++;
    }
	console.log("size is " + size);
    return size;
}

function paginationManager(openLastPage){
	console.log('paginationManager ->');
	
	console.log('number Tc To Load ' + AJS.$('#numberTcToLoad').val());
	if(AJS.$('#numberTcToLoad').val())
		itemsPerPageCfTc = parseInt(AJS.$('#numberTcToLoad').val(), 10);
	console.log('itemsPerPageCfTc ' + itemsPerPageCfTc);
	if(itemsPerPageCfTc !== null){
		console.log('counting pages');
		var currentItems = synapseSizeTcCf(currentOptionsCfTc);
		console.log('all items: ' + currentItems);
		var newPages = (currentItems - currentItems%itemsPerPageCfTc)/itemsPerPageCfTc;
		if(currentItems%itemsPerPageCfTc>0)
			newPages++;
		allPagesCfTc = newPages;
		
		console.log('pages: ' + newPages);
		if(currentPageCfTc > newPages || openLastPage)
			currentPageCfTc = newPages;
		console.log('current page: ' + currentPageCfTc);
		
		if(AJS.$('#' + paginatorDivIdCfTc).length)
			AJS.$('#' + paginatorDivIdCfTc).remove();
		var imin = itemsPerPageCfTc*(currentPageCfTc-1);
		var imax = itemsPerPageCfTc*currentPageCfTc-1;
		if(imax>currentItems)
			imax=currentItems;
		var i = 0;
		currentPageOptionsCfTc = '';
		console.log('first element index: ' + imin);
		console.log('last element index: ' + imax);
		for(var id in currentOptionsCfTc)
		{
			if(i>=imin && i<=imax){
				if(currentPageOptionsCfTc.length > 0)
					currentPageOptionsCfTc += ','
				currentPageOptionsCfTc+=id;
			}
			i++;
		}
		console.log('options on current page: ' + currentPageOptionsCfTc);
		if(newPages>1){
			console.log('add new paginator');
			var paginatorContainer = AJS.$('#synapse-tc-cf-edit-paginator');
			paginatorContainer.empty();
			var paginatorEl = AJS.$('<div/>', {
				'id': paginatorDivIdCfTc,
				'currentpage': '',
				'totalpages': newPages
			}).addClass('synapse-parents-pager');
			AJS.$(paginatorContainer).append(paginatorEl);
			console.log('current page ' + currentPageCfTc);
			paginator(paginatorDivIdCfTc, currentPageCfTc, newPages, 5, paginatorHandlerCfTcEdit, 'child', paginatorDivIdCfTc);
			AJS.$('#'+paginatorDivIdCfTc).css({'text-align':'left'});
			
			var msg = 'Field contains ' + currentItems + ' issue';
			if(currentItems>1)
				msg += 's';
			AJS.$('#cfTcAllMsg').html(msg);
			var added = currentItems - originalOptionsSizeCfTc;
			if(added<0)
				added = 0;
			msg = 'Added ' + added + ' issue';
			if(added>1)
				msg += 's';
		}
	}
	console.log('paginationManager <-');
}
